function RaidExtension.AE.Init(addon)
	if addon == Addon.identifier then
		if UISettings == nil then
			UISettings = { 
				button = { x = math.floor(UIParent:GetWidth() / 2), y = math.floor(UIParent:GetHeight() / 2) },
				window = { x = math.floor((UIParent:GetWidth() - 931) / 2), y = math.floor((UIParent:GetHeight() - 515) / 2) }
			}
		end

		RaidExtension.Storage.Event.ReceiveData = RaidExtension.Data.OnReceiveData
		RaidExtension.AE.UI.Context = UI.CreateContext(Addon.identifier)
		RaidExtension.Tooltip.Init(RaidExtension.AE.UI.Context)
		RaidExtension.AE.UI.Button = RaidExtension.GUI.CreateButton(RaidExtension.AE.UI.Context, iif(MINIMAPDOCKER, nil, UISettings.button.x), iif(MINIMAPDOCKER, nil, UISettings.button.y), 32, 32, 0, "button")
		if MINIMAPDOCKER then
			MINIMAPDOCKER.Register(Addon.toc.Name, RaidExtension.AE.UI.Button, RaidExtension.AE.ToggleWindow)
		else
			RaidExtension.EGUI.AttachDragFrame(RaidExtension.AE.UI.Button, false, "button", false)
		end
		RaidExtension.AE.UI.Button.Event.LeftClick = RaidExtension.AE.ToggleWindow

		RaidExtension.AE.UI.Window = UI.CreateFrame("RiftWindow", "", RaidExtension.AE.UI.Context)
		RaidExtension.AE.UI.Window:SetVisible(RaidExtension.AE.Visible)
		RaidExtension.AE.UI.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", UISettings.window.x, UISettings.window.y)
		RaidExtension.AE.UI.Window:SetWidth(931)
		RaidExtension.AE.UI.Window:SetHeight(515)
		RaidExtension.AE.UI.Window:SetTitle(string.upper(Addon.toc.Name))
		RaidExtension.AE.UI.Window:SetController("content")
		RaidExtension.EGUI.AttachDragFrame(RaidExtension.AE.UI.Window, true, "window", true)

		RaidExtension.AE.textureBg = RaidExtension.GUI.CreateTexture(RaidExtension.AE.UI.Window, 0, -11, 930, 526, 0, "img/bg-common.png")
		RaidExtension.AE.textureHeader = RaidExtension.GUI.CreateTexture(RaidExtension.AE.UI.Window, 310, 5, 310, 50, 2, "img/header-common.png")
		RaidExtension.GUI.CreateText(RaidExtension.AE.UI.Window, "BOTTOMRIGHT", 920, 510, "v." .. Addon.toc.Version).SetColor({.5, .5, .5}, 2)
		RaidExtension.GUI.CreateTexture(RaidExtension.AE.UI.Window, 1, -34, 50, 23, 1, "img/bg-left.png")
		RaidExtension.GUI.CreateTexture(RaidExtension.AE.UI.Window, 880, -34, 50, 23, 1, "img/bg-right.png")
		RaidExtension.GUI.CreateRiftButton(RaidExtension.AE.UI.Window, 4, -41, 2).Event.LeftPress = RaidExtension.AE.ToggleWindow

		for k, v in ipairs(RaidExtension.AE.TablePlane) do
			v.header = RaidExtension.GUI.CreateFrame(RaidExtension.AE.UI.Window, "TOPLEFT", 20, 68, 890, 20, 2)
			v.rowsArea = RaidExtension.GUI.CreateFrame(RaidExtension.AE.UI.Window, "TOPLEFT", 20, 90, 890, 400, 2)

			for sk, sv in ipairs(v.Columns) do
				sv.control = RaidExtension.GUI.CreateLink(v.header, "TOPLEFT", sv.headerX, -1, sv.headerName, function() RaidExtension.AE.Sort(sk) end)
			end

			for i = 1, 20 do
				v.Rows[i] = RaidExtension.EGUI.CreateRow(v.rowsArea, i, v.Columns)
			end
		end

		Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. Addon.name .. " ver." .. Addon.toc.Version .. " loaded. Type /" .. RaidExtension.AE.Command .. " to show a window.</font>", true)
	end
end

function RaidExtension.AE.Update()
	if Inspect.Time.Real() - RaidExtension.AE.UpdateTimer > 1 and RaidExtension.AE.Visible then
		RaidExtension.AE.UpdateTimer = Inspect.Time.Real()
		RaidExtension.Data.Update()
		RaidExtension.AE.Sort()
	end
end

function RaidExtension.AE.Sort(id)
	if id ~= nil then
		RaidExtension.AE.ColumnSelected = iif(RaidExtension.AE.ColumnSelected == id, -id, id)
	end
	for k, v in ipairs(RaidExtension.AE.TablePlane[RaidExtension.AE.GetPlane()].Columns) do
		v.control.Select(k == math.abs(RaidExtension.AE.ColumnSelected))
	end
	RaidExtension.AE.Refresh()
end

function RaidExtension.AE.Refresh()
	local list = RaidExtension.Data.Sort(RaidExtension.AE.TablePlane[RaidExtension.AE.GetPlane()].Columns[math.abs(RaidExtension.AE.ColumnSelected)].fieldName, RaidExtension.AE.ColumnSelected > 0)
	for i = 1, 20 do
		RaidExtension.AE.TablePlane[RaidExtension.AE.GetPlane()].Rows[i].Update(RaidExtension.Data.Units[list[i]])
	end

end

function RaidExtension.AE.ToggleWindow()
	RaidExtension.AE.Visible = not RaidExtension.AE.Visible
	RaidExtension.AE.UI.Window:SetVisible(RaidExtension.AE.Visible)
end

function RaidExtension.AE.GetPlane()
	return 1
end
