function RaidExtension.Meta.GetResistance(item, fDetail)
	local item = Inspect.Item.Detail(Utility.Item.Slot.Equipment(item))
	local result = {}
	for k, v in ipairs(RaidExtension.AE.Resistance) do
		result[v] = iif(fDetail, { item = 0, rune = 0 }, 0)
	end

	if item then
		for k, v in ipairs(RaidExtension.AE.Resistance) do
			if item.stats and item.stats[v] then
				if fDetail then result[v].item = result[v].item + item.stats[v] else result[v] = result[v] + item.stats[v] end
			end
			if item.statsRune and item.statsRune[v] then
				if fDetail then result[v].rune = result[v].rune + item.statsRune[v] else result[v] = result[v] + item.statsRune[v] end
			end
		end
	end
	return result
end

function RaidExtension.Meta.GetData()
	local data = {
		equipment = {
			chest = RaidExtension.Meta.GetResistance("chest", false),
			shoulders = RaidExtension.Meta.GetResistance("shoulders", false),
			sigil = RaidExtension.Meta.GetResistance("focus", true)
		}
	}

	local player = Inspect.Unit.Detail("player")
	if player then
		local class = RaidExtension.Utils.ParseClass(player.calling)
		local stats = Inspect.Stat()
		if stats then
			data.stats = {
				power = iif(class > 3, stats.powerSpell, stats.powerAttack),
				crit = iif(class > 3, stats.critSpell, stats.critAttack),
				critpower = stats.critPower,
				hit = stats.hit,
				strength = stats.strength,
				dexterity = stats.dexterity,
				intelligence = stats.intelligence,
				wisdom = stats.wisdom,
				endurance = stats.endurance,
				armor = stats.armor,
				block = stats.block,
				dodge = stats.dodge,
				guard = stats.guard
			}

			data.stats.resistance = { id = 0, value = 0 }
			for k, v in ipairs(RaidExtension.AE.Resistance) do
				data.stats[v] = stats[v]
				if data.stats.resistance.value < stats[v] then
					data.stats.resistance = { id = v, value = stats[v] }
				end		
			end
		end
	end

	return data
end
