function RaidExtension.Utils.ParseClass(unitClass)
	return iif(unitClass == "warrior", 2, iif(unitClass == "rogue", 3, iif(unitClass == "cleric", 4, iif(unitClass == "mage", 5, 1))))
end

function RaidExtension.Utils.Deflate(obj)
	return zlib.deflate()(RaidExtension.Utils.Serialize(obj, ""), "finish")
end

function RaidExtension.Utils.Inflate(obj)
	return RaidExtension.Utils.Deserialize(zlib.inflate()(obj, "finish"))
end

function RaidExtension.Utils.Serialize(obj, path)
	local result = ""
	for k, v in pairs(obj) do
		local val = tostring(v)
		local name = iif(path == "", "", path .. ".") .. k
		if type(v) == "table" then
			result = result .. RaidExtension.Utils.Serialize(v, name)
		else
			result = result .. name .. "=" .. val .. ","
		end
	end
	return result .. iif(path == "", "version=" .. Addon.toc.Version .. ",time=" .. Inspect.Time.Server(), "")
end

function RaidExtension.Utils.Deserialize(obj)
	local val = {}
	string.gsub(obj, "[,]?([^=]*)=([^,]*)", function (a,b) val[a]=b end)

	if val.version == Addon.toc.Version and Inspect.Time.Server() - val.time < 60 then
		return val
	else
		return {}
	end
end

function RaidExtension.Utils.GetTime(val)
	return iif(val > 3600, math.floor(val / 3600) .. "h", iif(val > 60, math.floor(val / 60) .. "m", math.floor(val) .. "s"))
end

function iif(condition, trueExpression, falseExpression)
	if condition then  
		return trueExpression
	else  
		return falseExpression
	end  
end

function ifnull(expression1, expression2)
	if expression1 == nil then  
		return expression2
	else  
		return expression1
	end  
end
